import java.util.ArrayList;
import java.util.Random;

public class BucketSort
{
	@SuppressWarnings("unchecked")

	private static final int NUMBER_TO_SORT = 100;

	public static void main(String[] args)
	{
		ArrayList<Key> list = new ArrayList<Key>();
		for(int i = 0; i < NUMBER_TO_SORT; ++i)
		{
			list.add(new Key());
		}

		System.out.println(list + " list.size() = "+ list.size());

		list = sort(list);

		System.out.println("");

		System.out.println(list + " list.size() = "+ list.size());

	}

	public static ArrayList<Key> sort(ArrayList<Key> list)
	{
		int k = 0;
		int n = 0;
		Key curKey;

		//find the largest
		for(int i = 0; i < list.size(); ++i)
		{
			curKey = (Key) list.get(i);
			k = curKey.getKey();
			if(n < k)
			{
				n = k;
			}
		}

		ArrayList<ArrayList<Key>> buckets = new ArrayList<ArrayList<Key>>();

		//fill buckets with n lists
		for(int i = 0; i <= n; ++i)
		{
			buckets.add(new ArrayList<Key>());
		}
		//start of algorithim
		while(list.size() > 0)
		{
			curKey = (Key) list.remove(0);
			k = curKey.getKey();
			(buckets.get(k)).add(curKey);
		}

		for(int i = 0; i <= n; ++i)
		{
			while((buckets.get(i)).size() > 0)
			{
				curKey = (buckets.get(i)).remove(0);
				list.add(curKey);
			}
		}

		return list;
	}


}

