import java.util.Scanner;


public class ShakerSort {

	public static void main(String []args)
	{
		Scanner in = new Scanner(System.in);
		System.out.println("How many items do you want to sort?");
		int numItms = in.nextInt();
		int[] a = new int[numItms];
		for (int i = 0; i < numItms; i++)
		{
			System.out.println("Please enter a number: ");
			a[i] = in.nextInt();
		}
		
		System.out.println("The array before sorting is:");
		for (int i = 0; i < numItms; i++)//prints out the elements of the array before sorting
		{
			System.out.print("" + a[i] + ", ");
		}
		System.out.println("");
		
		shakerSort(a);
		
		System.out.println("The array after sorting is:");
		for (int i = 0; i < numItms; i++)//prints out the elements of the array after sorting
		{
			System.out.print("" + a[i] + ", ");
		}
	}
	
	public static void shakerSort(int[] x)
	{//http://www.cise.ufl.edu/~sahni/dsaaj/enrich/c2/shaker.htm, http://leepoint.net/notes-java/data/arrays/32arraybubblesort.html
		int n = x.length;
		boolean swap = false;
		do
		{
		    for (int pass = 1; pass <= (n/2); pass++) 
		    {// count how many times
		    	swap = false;
		    	System.out.println("Yarp");
		        for (int i = (pass-1); i < n-pass; i++) 
		        {//this loop becomes shorter and shorter
		            if (x[i] > x[i+1]) 
		            {// exchange elements
		                int temp = x[i];  
		                x[i] = x[i+1];  
		                x[i+1] = temp;
		                swap = true;
		            }
		        }
		        for (int j = (n-pass-1); j >= pass; j--)
		        {
			        if (x[j] < x[j-1])
			        {
			        	int temp = x[j];  
			        	x[j] = x[j-1];  
			        	x[j-1] = temp;
			        	swap = true;
			        }
		        }
		        if (!swap)
		        {
		        	break;
		        }
		    }
		}
	    while (swap);
	}
}
