import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class SortAnalysis {
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws FileNotFoundException{
		Scanner in = new Scanner(new File(args[0]));
		in.useDelimiter("[,\n]");
		ArrayList<Object> dataCol1 = new ArrayList<Object>();
		ArrayList<Object> dataCol2 = new ArrayList<Object>();
		in.nextLine();

		while(in.hasNext())
		{
			String first = in.next();
			String last = in.next();
			String phone = in.next();
			//System.out.println("last= " +last + " first= " + first + " phone= " + phone);
			Person temp = new Person(last, first, phone);
			dataCol1.add(temp);
			dataCol2.add(temp);
		}
		/*if(dataCol1.clone() instanceof ArrayList<?>){
			dataCol2 = (ArrayList<Object>) dataCol1.clone();
		}*/
		
		System.out.println("size of dataCol is " + dataCol1.size());
		long startTime = System.currentTimeMillis();

		Collections.sort(dataCol1, new PersonComparator());
		
		long endTime = System.currentTimeMillis();

		System.out.println("Collections.sort took " + (endTime - startTime) + " milliseconds");
		System.out.println(" ");
		
		startTime = System.currentTimeMillis();
		
		System.out.println("Bubble Sort before:");
		for (int i = 0; i < 10; i++)
		{
			Person temp = (Person) dataCol2.get(i);
			String lastN = temp.getLastName();
			String firstN = temp.getFirstName();
			System.out.println(lastN + ", " + firstN);
		}
		System.out.println(" ");
		
		ShakerSort.sort(dataCol2, new PersonComparator());
		
		endTime = System.currentTimeMillis();

		//System.out.println("Insertion sort took " + (endTime - startTime) + " milliseconds");
		
		System.out.println("Bubble Sort after:");
		for (int i = 0; i < 10; i++)
		{
			Person temp = (Person) dataCol2.get(i);
			String lastN = temp.getLastName();
			String firstN = temp.getFirstName();
			System.out.println(lastN + ", " + firstN);
		}
		
		System.out.println(" ");
		System.out.println("Bubble sort took " + (endTime - startTime) + " milliseconds");
		
	}

}
