import java.util.ArrayList;
import java.util.Random;

public class RadixSort
{
	@SuppressWarnings("unchecked")

	private static final int NUMBER_TO_SORT = 100;

	public static void main(String[] args)
	{
		ArrayList<Keys> list = new ArrayList<Keys>();
		for(int i = 0; i < NUMBER_TO_SORT; ++i)
		{
			list.add(new Keys());
		}

		System.out.println(list + " list.size() = "+ list.size());

		list = sort1(list);

		System.out.println("");

		System.out.println(list + " list.size() = "+ list.size());

		list = sort2(list);

		System.out.println("");

		System.out.println(list + " list.size() = "+ list.size());

		list = sort3(list);

		System.out.println("");

		System.out.println(list + " list.size() = "+ list.size());

		list = sort4(list);

		System.out.println("");

		System.out.println(list + " list.size() = "+ list.size());




	}

	public static ArrayList<Keys> sort1(ArrayList<Keys> list)
	{
		int k = 0;
		int n = 0;
		Keys curKey;

		//find the largest
		for(int i = 0; i < list.size(); ++i)
		{
			curKey = (Keys) list.get(i);
			k = curKey.getKey1();
			if(n < k)
			{
				n = k;
			}
		}

		ArrayList<ArrayList<Keys>> buckets = new ArrayList<ArrayList<Keys>>();

		//fill buckets with n lists
		for(int i = 0; i <= n; ++i)
		{
			buckets.add(new ArrayList<Keys>());
		}
		//start of algorithim
		while(list.size() > 0)
		{
			curKey = (Keys) list.remove(0);
			k = curKey.getKey1();
			(buckets.get(k)).add(curKey);
		}

		for(int i = 0; i <= n; ++i)
		{
			while((buckets.get(i)).size() > 0)
			{
				curKey = (buckets.get(i)).remove(0);
				list.add(curKey);
			}
		}

		return list;
	}

	public static ArrayList<Keys> sort2(ArrayList<Keys> list)
	{
		int k = 0;
		int n = 0;
		Keys curKey;

		//find the largest
		for(int i = 0; i < list.size(); ++i)
		{
			curKey = (Keys) list.get(i);
			k = curKey.getKey2();
			if(n < k)
			{
				n = k;
			}
		}

		ArrayList<ArrayList<Keys>> buckets = new ArrayList<ArrayList<Keys>>();

		//fill buckets with n lists
		for(int i = 0; i <= n; ++i)
		{
			buckets.add(new ArrayList<Keys>());
		}
		//start of algorithim
		while(list.size() > 0)
		{
			curKey = (Keys) list.remove(0);
			k = curKey.getKey2();
			(buckets.get(k)).add(curKey);
		}

		for(int i = 0; i <= n; ++i)
		{
			while((buckets.get(i)).size() > 0)
			{
				curKey = (buckets.get(i)).remove(0);
				list.add(curKey);
			}
		}

		return list;
	}

	public static ArrayList<Keys> sort3(ArrayList<Keys> list)
	{
		int k = 0;
		int n = 0;
		Keys curKey;

		//find the largest
		for(int i = 0; i < list.size(); ++i)
		{
			curKey = (Keys) list.get(i);
			k = curKey.getKey3();
			if(n < k)
			{
				n = k;
			}
		}

		ArrayList<ArrayList<Keys>> buckets = new ArrayList<ArrayList<Keys>>();

		//fill buckets with n lists
		for(int i = 0; i <= n; ++i)
		{
			buckets.add(new ArrayList<Keys>());
		}
		//start of algorithim
		while(list.size() > 0)
		{
			curKey = (Keys) list.remove(0);
			k = curKey.getKey3();
			(buckets.get(k)).add(curKey);
		}

		for(int i = 0; i <= n; ++i)
		{
			while((buckets.get(i)).size() > 0)
			{
				curKey = (buckets.get(i)).remove(0);
				list.add(curKey);
			}
		}

		return list;
	}

	public static ArrayList<Keys> sort4(ArrayList<Keys> list)
	{
		int k = 0;
		int n = 0;
		Keys curKey;

		//find the largest
		for(int i = 0; i < list.size(); ++i)
		{
			curKey = (Keys) list.get(i);
			k = curKey.getKey4();
			if(n < k)
			{
				n = k;
			}
		}

		ArrayList<ArrayList<Keys>> buckets = new ArrayList<ArrayList<Keys>>();

		//fill buckets with n lists
		for(int i = 0; i <= n; ++i)
		{
			buckets.add(new ArrayList<Keys>());
		}
		//start of algorithim
		while(list.size() > 0)
		{
			curKey = (Keys) list.remove(0);
			k = curKey.getKey4();
			(buckets.get(k)).add(curKey);
		}

		for(int i = 0; i <= n; ++i)
		{
			while((buckets.get(i)).size() > 0)
			{
				curKey = (buckets.get(i)).remove(0);
				list.add(curKey);
			}
		}

		return list;
	}

}

